import {ResponseFactory} from "./ResponseFactory";
import {Request} from "../lifecycle/Request";

export function html(value: string): HTMLResponseFactory {
    return new HTMLResponseFactory(value)
}

export class HTMLResponseFactory extends ResponseFactory {
    constructor(
        public readonly value: string,
    ) { super() }

    public async write(request: Request) {
        request = await super.write(request)
        request.response.setHeader('Content-Type', 'text/html; charset=utf-8')
        request.response.body = this.value
        return request
    }
}
