import {Canonical, CanonicalDefinition} from "./Canonical";
import {isStaticClass, StaticClass} from "@extollo/di";
import {InvalidCanonicalExportError} from "./CanonicalInstantiable";

export class CanonicalStatic<T, T2> extends Canonical<StaticClass<T, T2>> {
    public async initCanonicalItem(definition: CanonicalDefinition): Promise<StaticClass<T, T2>> {
        if ( isStaticClass(definition.imported.default) ) {
            return definition.imported.default
        }

        if ( isStaticClass(definition.imported[definition.canonicalName.split(':').reverse()[0]]) ) {
            return definition.imported[definition.canonicalName.split(':').reverse()[0]]
        }

        throw new InvalidCanonicalExportError(definition.originalName)
    }
}
